/* $Id: $ */

/* Copyright (C) 1999 Petr Novak, Charles University, Prague.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <cim.h>
#include <stdlib.h>
#include <string.h>

#define MAX_INT (~(1L<<31))

#define digit (s[i]>='0' && s[i]<='9')
#define more (i<j)
#define fortegn ((s[i]=='-')?-1:(s[i]=='+')?1:0)
#define skipblanke for(;i<j && (s[i]==' ' || s[i]=='\t');i++);
#define parserror(t) {resultM = (t); return 0; }

/* parse t: lastError == NULL on success */

/***************************************************************************/
static char * resultM;

char * lastError () { return resultM; }

long getfrac (char * t)
{
  char *s = t;
  int sign;
  long i = 0, j = strlen (t);
  long n = 0;

  resultM = NULL;

  skipblanke;
  if (!more) parserror ("Getfrac (0): Can't find any grouped item");

  sign = fortegn;
  if (sign)
    i++;
  else
    sign = 1;
  skipblanke;
  if (!more) parserror ("Getfrac (1): Can't find any grouped item");

  if (!digit)
    {
      if (s[i] == __currentdecimalmark)
        {
          i++;
          if (!digit)
            parserror ("Getfrac (2): Illegal grouped item");
        }
      else
        parserror ("Getfrac (3): Can't find any grouped item");
    }

  while (1)
    {
      for (; more && digit; i++)
        {
          if (n > MAX_INT / 10)
            goto forstort;
          if (n == MAX_INT / 10)
            if ((s[i] - '0') > MAX_INT % 10)
              goto forstort;
          n = 10 * n + s[i] - '0';
        }
      if (!more)
        goto ut;
      skipblanke;
      if (!more)
        goto ut;
      if (!digit)
        {
          if (s[i] == __currentdecimalmark)
            {
              i++;
              if (digit) continue;
            }
          skipblanke;
          if (s[i]) parserror ("Getfrac (4): Unrecognized character");
          goto ut;
        }
    }
ut:
  return (sign * n);
forstort:
  parserror ("Getfrac (4): To big grouped item");
  return (sign * n);
}

/***************************************************************************/

long getint (char * t, char ** res)
{
  char *s = t;
  int sign;
  long i = 0, j = strlen (t), n = 0;

  resultM = NULL;

  skipblanke;
  if (!more)
    parserror ("Getint: Can't find any integer item");
  sign = fortegn;
  if (sign)
    i++;
  else
    sign = 1;
  skipblanke;
  if (!more)
    parserror ("Getint: Can't find any integer item");
  if (!digit)
    parserror ("Getint: Can't find any integer item");
  for (; more && digit; i++)
    {
      if (n > MAX_INT / 10)
        goto forstort;
      if (n == MAX_INT / 10)
        if ((s[i] - '0') > MAX_INT % 10)
          goto forstort;
      n = 10 * n + s[i] - '0';
    }
  skipblanke;
  if (s[i]) parserror ("Getint: Unrecognized character");
  return (sign * n);
forstort:
  parserror ("Getint: To big integer item");
  return (sign * n);
}

/***************************************************************************/

double getreal (char *t, char ** res)
{
  char *s = t;
  int sign;
  static char cs[__RTPUTTEXTLENGTH + 1];
  long csi = 0,
    i = 0,
    j = strlen (t),
    p;
  double r;

  union
    {
      double d;
      struct
        {
          unsigned long i1;
          long i2;
        }
      dasii;
    }
  value;

  resultM = NULL;

  skipblanke;
  if (!more)
    parserror ("Getreal: Can't find any real item");
  if (sign = fortegn)
    i++;
  if (sign == -1)
    cs[csi++] = '-';
  skipblanke;
  if (!more)
    parserror ("Getreal: Can't find any integer item");
  if (!digit)
    if (s[i] == __currentlowten)
      {
        cs[csi++] = '1';
      }
    else if (s[i] != __currentdecimalmark)
      parserror ("Getreal: Illegal real item");
  for (; more && digit; i++)
    {
      if (csi >= __RTPUTTEXTLENGTH)
        goto texttolong;
      cs[csi++] = s[i];
    }
  if (s[i] == __currentdecimalmark)
    {
      i++;
      cs[csi++] = '.';
      if (!digit)
        parserror ("Getreal: Can't find any real item");
      for (; more && digit; i++)
        {
          if (csi >= __RTPUTTEXTLENGTH)
            goto texttolong;
          cs[csi++] = s[i];
        }
    }
  if (s[i] == __currentlowten)
    {
      i++;
      cs[csi++] = 'e';
      skipblanke;
      if (!more)
        parserror ("Getreal: Can't find any real item");
      if (sign = fortegn)
        i++;
      if (csi >= __RTPUTTEXTLENGTH)
        goto texttolong;
      if (sign == -1)
        cs[csi++] = '-';
      skipblanke;
      if (!more)
        parserror ("Getreal: Can't find any real item");
      for (; more && digit; i++)
        {
          if (csi >= __RTPUTTEXTLENGTH)
            goto texttolong;
          cs[csi++] = s[i];
        }
    }
  if (csi > __RTPUTTEXTLENGTH)
    goto texttolong;
  skipblanke;
  if (s[i]) parserror ("Getreal: Unrecognized character");
  cs[csi++] = '\0';
  r= strtod (cs, __NULL);
#define emask (2047L<<20)
  value.d = r;
  if ((value.dasii.i2 & emask) == emask)
    goto texttolong;
  return (r);
texttolong:
  parserror ("Getreal: To big real item");
  /* NOTREACHED */
}
