/* $Id: $ */

/* Copyright (C) 1999 Petr Novak, Charles University, Prague.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
   cmp compares 2 files.
   return: 0 ... files are equal, 1 ... files differ
*/

#include <stdio.h>
#include <string.h>

#define MAXCHARS (FILENAME_MAX)

typedef char tline[MAXCHARS];
FILE * f[2];

int getline (int i, char * to)
{
  return (fgets (to, MAXCHARS, f [i]) != NULL);
}
  
cmp (char * fname1, char * fname2)
{
  tline buf [2];    // compare buffer
  int readRes;

  f[0] = fopen (fname1, "r");
  if (f[0] == NULL) {
    return 1;
  }
  f[1] = fopen (fname2, "r");
  if (f[1] == NULL) {
    fclose (f[0]); 
    return 1;
  }
  // printf ("opened\n");
  readRes = 3;
  while (readRes == 3)
  {
    readRes = getline (0, buf [0]) + getline (1, buf [1]) * 2;

    if (readRes == 3                         // both sides have line
        && strcmp (buf [0], buf [1]) != 0)   // lines differ  
      readRes = 1;
  }

  fclose (f[0]);
  fclose (f[1]);

  return (readRes != 0 && readRes != 3);
}
